package tr.com.bilyazilim.kosgeb.kobibeyannamesi.evrak;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

import javax.ejb.Remove;
import javax.persistence.EntityManager;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.End;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.contexts.Contexts;
import org.jboss.seam.faces.FacesMessages;
import org.jboss.seam.international.StatusMessages;
import org.jboss.seam.international.StatusMessage.Severity;
import org.jboss.seam.log.Log;

import tr.com.bilyazilim.kosgeb.kobibeyannamesi.action.FuarList;
import tr.com.bilyazilim.kosgeb.kobibeyannamesi.action.PdoctypeHome;
import tr.com.bilyazilim.kosgeb.kobibeyannamesi.action.PdoctypeList;
import tr.com.bilyazilim.kosgeb.kobibeyannamesi.model.Docbin;
import tr.com.bilyazilim.kosgeb.kobibeyannamesi.model.Document;
import tr.com.bilyazilim.kosgeb.kobibeyannamesi.model.Firm;
import tr.com.bilyazilim.kosgeb.kobibeyannamesi.model.Fuar;
import tr.com.bilyazilim.kosgeb.kobibeyannamesi.model.Pdoctype;
import tr.com.bilyazilim.kosgeb.manager.FileUploadManagerBean;
import tr.com.bilyazilim.kosgeb.util.File;

@Name("evrakEklemeIslemleri")
@Scope(ScopeType.PAGE)
public class EvrakEklemeIslemleriBean implements EvrakEklemeIslemleri, Serializable
{
    /**
	 *
	 */
	private static final long serialVersionUID = -4801093270832318321L;

	@Logger private Log log;

	@In	FacesMessages facesMessages;
	
	@In private EntityManager entityManager;
	
    @In StatusMessages statusMessages;

    @In(value="fileUploadManager", scope=ScopeType.SESSION,required=false) @Out(value="fileUploadManager", scope=ScopeType.SESSION, required=false)
    FileUploadManagerBean fileUploadManager;
    
    @In(value="firmFound", scope = ScopeType.CONVERSATION,required=false)
    private Firm firm;

    private PdoctypeList pdocsList =null;

    private FuarList fuarList = null;
    

	private List<Pdoctype> pdocs =null ;

    private List<Fuar> fuars = null;

    private Map<String,Integer> pdocsMaps;

    private List<String> pdocsItems;
    
    private Map<String,Long> fuarsMaps;

    private List<String> fuarsItems;

    private Date tarih1;
    
    private Date tarih2;
    
    private String selectedFuar = "";
    
	private Double supportAmount;
    
    private String selectedDocType ="";
    
	public PdoctypeList getPdocsList() {
		return pdocsList;
	}

	public void setPdocsList(PdoctypeList pdocsList) {
		this.pdocsList = pdocsList;
	}

	public Map<String, Integer> getPdocsMaps() {
		return pdocsMaps;
	}

	public void setPdocsMaps(Map<String, Integer> pdocsMaps) {
		this.pdocsMaps = pdocsMaps;
	}

	public List<String> getPdocsItems() {
		return pdocsItems;
	}

	public void setPdocsItems(List<String> pdocsItems) {
		this.pdocsItems = pdocsItems;
	}

	@Create
	@Begin(join=true)
	public void init(){
    	pdocsList = new PdoctypeList();
    	pdocsList.setRestrictionExpressionStrings(new ArrayList<String>());
    	pdocs = pdocsList.getResultList();
    	pdocsMaps = new HashMap<String, Integer>();
    	pdocsItems = new ArrayList<String>();
    	for(Pdoctype pdocc: pdocs){
    		pdocsMaps.put(pdocc.getPdoctype(),pdocc.getId());
    		pdocsItems.add(pdocc.getPdoctype());
    	}
    	
    	fuarList = new FuarList();
    	fuarList.setRestrictionExpressionStrings(new ArrayList<String>());
    	fuars = fuarList.getResultList();
    	fuarsMaps = new HashMap<String,Long>();
    	fuarsItems = new ArrayList<String>();
    	
    	for(Fuar fuarr: fuars){
    		fuarsMaps.put(fuarr.getFuaradi(),fuarr.getFuarid());
    		fuarsItems.add(fuarr.getFuaradi());
    	}
    	
	}

    @End
    public void saveUploadData(){
//    	FileUploadBean fileUpload =(FileUploadBean) Contexts.getConversationContext().get("fileUploadBean");
    	//firm = (Firm) Contexts.getEventContext().get("firm");
    	List<File> docbinList = (fileUploadManager.getFileWrapper()).getFileList();

    	if(docbinList.size()<1)
    		return; //TODO raise FacesMessage: no fileuploaded.
    	    	
    	if(firm==null)
    		firm = (Firm)Contexts.getConversationContext().get("foundFirm");
    	else 
    		//raise firm not selected FacesMessage return.
    		;
    	
    	Document doc = new Document();
    	HashSet<Docbin> docBins = new HashSet<Docbin>();
    	if(getTarih1()!=null)
    		doc.setDdate(getTarih1());
    	else 
    		doc.setDdate(new Date());
    	if(getTarih2()!=null)
    		doc.setEnddate(getTarih2());
    	
    	PdoctypeHome pdocTypeHome = new PdoctypeHome();
    	pdocTypeHome.create();
    	pdocTypeHome.setId(this.pdocsMaps.get(selectedDocType));
    	Pdoctype typeDoc = pdocTypeHome.find();
    	
		int pageNum =0;
		doc.setPdoctype(typeDoc);
    	for(File docbinInstance : docbinList){
    		Docbin docBin = new Docbin();
    		docBin.setDocument(doc);
    		docBin.setDocpagenum(++pageNum);
    		docBin.setDocoid(docbinInstance.getData());
    		docBin.setDocname(docbinInstance.getName());
    		docBins.add(docBin);
    	}
    	doc.setFirm(firm);
    	doc.setDnumofpages(pageNum);
    	doc.setFirmtaxnum(firm.getFtaxnum());
    	doc.setDocbins(docBins);
    	getEntityManager().persist(doc);
    	
    	if(fuarsMaps.get(selectedFuar)!=null) {
    		doc.setFuarId(fuarsMaps.get(selectedFuar));
    	} else {
    		Fuar yeniFuar = new Fuar(getSelectedFuar());
    		getEntityManager().persist(yeniFuar);
    		doc.setFuarId(yeniFuar.getFuarid());
    	}
    	
    	for(Docbin docbin: docBins) {
    		getEntityManager().persist(docbin);
    	}

    	fileUploadManager.getFileWrapper().clear();
    	this.selectedFuar=null;
    	this.tarih1=null;
    	this.tarih2=null;
    	facesMessages.add(Severity.INFO, "#{messages.firmPersistSuccessful}", null);
    
    }


    @Remove @Destroy
    public void destroy() {}


	public void setFirm(Firm firm) {
		this.firm = firm;
	}

	public Firm getFirm() {
		return firm;
	}


	public void setLog(Log log) {
		this.log = log;
	}

	public Log getLog() {
		return log;
	}

	public void setPdocs(List<Pdoctype> pdocs) {
		this.pdocs = pdocs;
	}

	public List<Pdoctype> getPdocs() {
		return pdocs;
	}

	public void setSupportAmount(Double supportAmount) {
		this.supportAmount = supportAmount;
	}

	public Double getSupportAmount() {
		return supportAmount;
	}

	public void setSelectedDocType(String selectedDocType) {
		this.selectedDocType = selectedDocType;
	}


	public String getSelectedDocType() {
		return selectedDocType;
	}

	public void setEntityManager(EntityManager entityManager) {
		this.entityManager = entityManager;
	}

	public EntityManager getEntityManager() {
		return entityManager;
	}

	public void setTarih1(Date tarih1) {
		this.tarih1 = tarih1;
	}

	public Date getTarih1() {
		return tarih1;
	}

	public void setTarih2(Date tarih2) {
		this.tarih2 = tarih2;
	}

	public Date getTarih2() {
		return tarih2;
	}

	public void setSelectedFuar(String fuarAdi) {
		this.selectedFuar = fuarAdi;
	}

	public String getSelectedFuar() {
		return selectedFuar;
	}

    public FuarList getFuarList() {
		return fuarList;
	}

	public void setFuarList(FuarList fuarList) {
		this.fuarList = fuarList;
	}

	public List<Fuar> getFuars() {
		return fuars;
	}

	public void setFuars(List<Fuar> fuars) {
		this.fuars = fuars;
	}

	public Map<String, Long> getFuarsMaps() {
		return fuarsMaps;
	}

	public void setFuarsMaps(Map<String, Long> fuarsMaps) {
		this.fuarsMaps = fuarsMaps;
	}

	public List<String> getFuarsItems() {
		return fuarsItems;
	}

	public void setFuarsItems(List<String> fuarsItems) {
		this.fuarsItems = fuarsItems;
	}



}
